Index: /palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/read_3d_binary.f90	(revision 2231)
+++ /palm/trunk/SOURCE/read_3d_binary.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new surface concept - move output of surface varariables
+! to surface_mod
 ! 
 ! Former revisions:
@@ -120,15 +121,13 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, ol, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst,        &
-               prr, precipitation_amount, qr,                                  &
-               qrs, qrsws, qrswst, qs, qsws, qswst, s, sa, saswsb, saswst,     &
-               ss, ssws, sswst, rif_wall, shf, ss, ts, tswst, u, u_m_l, u_m_n, &
-               u_m_r, u_m_s, us, usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s,   &
-               vpt, vsws, vswst, w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
+        ONLY:  e, kh, km, p, pt, q, ql, qc, nr, prr, precipitation_amount, qr, &
+               s, sa, u, u_m_l, u_m_n, u_m_r, u_m_s, v, v_m_l, v_m_n, v_m_r,   &
+               v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
 
     USE averaging
 
     USE control_parameters,                                                    &
-        ONLY:  iran, message_string, outflow_l, outflow_n, outflow_r, outflow_s
+        ONLY:  iran, land_surface, message_string, outflow_l, outflow_n,       &
+               outflow_r, outflow_s
 
     USE cpulog,                                                                &
@@ -142,5 +141,5 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, lsm_read_restart_data
+        ONLY:  lsm_read_restart_data
 
     USE particle_attributes,                                                   &
@@ -161,4 +160,6 @@
         ONLY:  spectrum_x, spectrum_y
 
+    USE surface_mod,                                                           &
+        ONLY :  surface_read_restart_data
 
     IMPLICIT NONE
@@ -436,4 +437,8 @@
              nync = nynfa(i,k) + offset_ya(i,k)
 
+             write(9,*) "f", nxlf, nxrf, nysf, nynf
+             write(9,*) "c", nxlc, nxrc, nysc, nync
+
+
 
              SELECT CASE ( TRIM( field_chr ) )
@@ -494,23 +499,4 @@
                    nr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                     tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nrs' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   nrs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nrsws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   nrsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nrswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   nrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                CASE ( 'ol' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ol(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'p' )
@@ -637,19 +623,4 @@
                                     tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'qrs' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qrs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qrsws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qrsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qrswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'ql_c_av' )
                    IF ( .NOT. ALLOCATED( ql_c_av ) )  THEN
@@ -675,14 +646,4 @@
                    ql_vp_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                         tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qs' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qsws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'qsws_av' )
@@ -694,9 +655,4 @@
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'qswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'qv_av' )
                    IF ( .NOT. ALLOCATED( qv_av ) )  THEN
@@ -722,14 +678,5 @@
                    rho_ocean_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                 tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rif_wall' )
-                   IF ( k == 1 )  THEN
-                      ALLOCATE( tmp_4d(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp, &
-                                       nxl_on_file-nbgp:nxr_on_file+nbgp,1:4) )
-                      READ ( 13 )  tmp_4d
-                   ENDIF
-                   rif_wall(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp,:) = &
-                            tmp_4d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp,:)
-                            
+                           
                 CASE ( 's' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -757,19 +704,4 @@
                    sa_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                     tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'saswsb' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   saswsb(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'saswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   saswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'shf' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   shf(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                      tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'shf_av' )
@@ -811,14 +743,4 @@
                    ENDIF
                    
-                CASE ( 'ss' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ss(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'ssws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ssws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'ssws_av' )
                    IF ( .NOT. ALLOCATED( ssws_av ) )  THEN
@@ -828,15 +750,5 @@
                    ssws_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'sswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   sswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp) 
                  
-                CASE ( 'ts' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ts(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'ts_av' )
                    IF ( .NOT. ALLOCATED( ts_av ) )  THEN
@@ -847,9 +759,4 @@
                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'tswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   tswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'u' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -905,19 +812,4 @@
                    ENDIF
 
-                CASE ( 'us' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   us(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'usws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   usws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'uswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   uswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'us_av' )
                    IF ( .NOT. ALLOCATED( us_av ) )  THEN
@@ -994,14 +886,4 @@
                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'vsws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   vsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'vswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   vswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'w' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1058,9 +940,4 @@
                    DEALLOCATE( tmp_3dwws )
 
-                CASE ( 'z0' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   z0(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'z0_av' )
                    IF ( .NOT. ALLOCATED( z0_av ) )  THEN
@@ -1071,9 +948,4 @@
                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'z0h' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   z0h(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'z0h_av' )
                    IF ( .NOT. ALLOCATED( z0h_av ) )  THEN
@@ -1083,9 +955,4 @@
                    z0h_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'z0q' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   z0q(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'z0q_av' )
@@ -1128,4 +995,10 @@
 
        ENDDO  ! loop over variables
+!
+!--    Read surface related variables
+       CALL surface_read_restart_data( i, nxlfa, nxl_on_file, nxrfa,           &
+                                       nxr_on_file, nynfa, nyn_on_file, nysfa, &
+                                       nys_on_file, offset_xa, offset_ya,      &
+                                       overlap_count(i) )
 
 !
Index: /palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/read_var_list.f90	(revision 2231)
+++ /palm/trunk/SOURCE/read_var_list.f90	(revision 2232)
@@ -20,6 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+! Replace wall_qflux, wall_sflux by wall_humidityflux and wall_scalarflux; add
+! wall_salinityflux
+! +tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y, 
+!  tunnel_wall_depth
+!
 ! Former revisions:
 ! -----------------
@@ -705,4 +708,14 @@
           CASE ( 'collision_turbulence' )
              READ ( 13 )  collision_turbulence
+          CASE ( 'tunnel_height' )
+             READ ( 13 )  tunnel_height
+          CASE ( 'tunnel_length' )
+             READ ( 13 )  tunnel_length
+          CASE ( 'tunnel_width_x' )
+             READ ( 13 )  tunnel_width_x
+          CASE ( 'tunnel_width_y' )
+             READ ( 13 )  tunnel_width_y
+          CASE ( 'tunnel_wall_depth' )
+             READ ( 13 )  tunnel_wall_depth
           CASE ( 'turbulent_inflow' )
              READ ( 13 )  turbulent_inflow
@@ -769,8 +782,10 @@
           CASE ( 'wall_heatflux' )
              READ ( 13 )  wall_heatflux
-          CASE ( 'wall_qflux' )
-             READ ( 13 )  wall_qflux
-          CASE ( 'wall_sflux' )
-             READ ( 13 )  wall_sflux
+          CASE ( 'wall_humidityflux' )
+             READ ( 13 )  wall_humidityflux
+          CASE ( 'wall_scalarflux' )
+             READ ( 13 )  wall_scalarflux
+          CASE ( 'wall_salinityflux' )
+             READ ( 13 )  wall_salinityflux
           CASE ( 'w_max' )
              READ ( 13 )  w_max
@@ -851,4 +866,5 @@
 
     READ ( 13 )  version_on_file
+
 
 !
@@ -932,5 +948,4 @@
     ENDIF
 
-
 !
 !-- Now read and check some control parameters and skip the rest
Index: /palm/trunk/SOURCE/subsidence_mod.f90
===================================================================
--- /palm/trunk/SOURCE/subsidence_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/subsidence_mod.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -195,6 +195,6 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_s_inner,&
-                  nzt
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,        &
+                  wall_flags_0
 
        USE kinds
@@ -225,11 +225,15 @@
           DO  j = nys, nyn
 
-             DO  k = nzb_s_inner(j,i)+1, nzt 
+             DO  k = nzb+1, nzt 
                 IF ( w_subs(k) < 0.0_wp )  THEN    ! large-scale subsidence
                    tmp_tend = - w_subs(k) *                                    &
-                              ( var(k+1,j,i) - var(k,j,i) ) * ddzu(k+1)
+                              ( var(k+1,j,i) - var(k,j,i) ) * ddzu(k+1) *      &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ELSE                               ! large-scale ascent
                    tmp_tend = - w_subs(k) *                                    &
-                              ( var(k,j,i) - var(k-1,j,i) ) * ddzu(k)
+                              ( var(k,j,i) - var(k-1,j,i) ) * ddzu(k) *        &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDIF
 
@@ -238,5 +242,7 @@
                 IF ( large_scale_forcing )  THEN
                    sums_ls_l(k,ls_index) = sums_ls_l(k,ls_index) + tmp_tend    &
-                                   * weight_substep(intermediate_timestep_count)
+                                 * weight_substep(intermediate_timestep_count) &
+                                 * MERGE( 1.0_wp, 0.0_wp,                      &
+                                          BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDIF
              ENDDO
@@ -304,5 +310,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxrg, nyng, nys, nysg, nzb_s_inner, nzb, nzt
+           ONLY:  nxl, nxlg, nxrg, nyng, nys, nysg, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -330,9 +336,14 @@
 !
 !--    Influence of w_subsidence on the current tendency term
-       DO  k = nzb_s_inner(j,i)+1, nzt 
+       DO  k = nzb+1, nzt 
           IF ( w_subs(k) < 0.0_wp )  THEN      ! large-scale subsidence
-             tmp_tend = - w_subs(k) * ( var(k+1,j,i) - var(k,j,i) ) * ddzu(k+1)
+             tmp_tend = - w_subs(k) * ( var(k+1,j,i) - var(k,j,i) )            &
+                                    * ddzu(k+1)                                &
+                                    * MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 0 ) )
           ELSE                                 ! large-scale ascent
-             tmp_tend = - w_subs(k) * ( var(k,j,i) - var(k-1,j,i) ) * ddzu(k)
+             tmp_tend = - w_subs(k) * ( var(k,j,i) - var(k-1,j,i) ) * ddzu(k)  &
+                                    * MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 0 ) )
           ENDIF
 
@@ -341,5 +352,7 @@
           IF ( large_scale_forcing )  THEN
              sums_ls_l(k,ls_index) = sums_ls_l(k,ls_index) + tmp_tend          &
-                                   * weight_substep(intermediate_timestep_count)
+                                  * weight_substep(intermediate_timestep_count)&
+                                  * MERGE( 1.0_wp, 0.0_wp,                     &
+                                           BTEST( wall_flags_0(k,j,i), 0 ) )
           ENDIF
        ENDDO
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 2231)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new surface concept
 ! 
 ! Former revisions:
@@ -132,7 +132,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, nr, ol, p, pt, precipitation_rate, q, qc, ql, ql_c,     &
-               ql_v, qr, qsws, rho_ocean, s, sa, shf, ssws, ts, u, us, v, vpt, w, z0,&
-               z0h, z0q
+        ONLY:  dzw, e, nr, p, pt, precipitation_rate, q, qc, ql, ql_c, ql_v,   &
+               qr, rho_ocean, s, sa, u, v, vpt, w
 
     USE averaging,                                                             &
@@ -147,6 +146,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  average_count_3d, cloud_physics, doav, doav_n, rho_surface,     &
-               urban_surface, varnamelength
+        ONLY:  average_count_3d, cloud_physics, doav, doav_n, land_surface,    &
+               rho_surface, urban_surface, varnamelength
 
     USE cpulog,                                                                &
@@ -159,5 +158,5 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, lsm_3d_data_averaging
+        ONLY:  lsm_3d_data_averaging
 
     USE particle_attributes,                                                   &
@@ -167,4 +166,7 @@
         ONLY:  radiation, radiation_3d_data_averaging
 
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
     USE urban_surface_mod,                                                     &
         ONLY:  usm_average_3d_data
@@ -173,8 +175,9 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i   !< running index
+    INTEGER(iwp) ::  i   !< grid index x direction
     INTEGER(iwp) ::  ii  !< running index
-    INTEGER(iwp) ::  j   !< running index
-    INTEGER(iwp) ::  k   !< running index
+    INTEGER(iwp) ::  j   !< grid index y direction
+    INTEGER(iwp) ::  k   !< grid index x direction
+    INTEGER(iwp) ::  m   !< running index surface type
     INTEGER(iwp) ::  n   !< 
 
@@ -490,8 +493,18 @@
 
           CASE ( 'ol*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ol_av(j,i) = ol_av(j,i) + ol(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                ol_av(j,i) = ol_av(j,i) + surf_def_h(0)%ol(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                ol_av(j,i) = ol_av(j,i) + surf_lsm_h%ol(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                ol_av(j,i) = ol_av(j,i) + surf_usm_h%ol(m)
              ENDDO
 
@@ -645,8 +658,18 @@
 
           CASE ( 'qsws*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   qsws_av(j,i) = qsws_av(j,i) + qsws(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                qsws_av(j,i) = qsws_av(j,i) + surf_def_h(0)%qsws(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                qsws_av(j,i) = qsws_av(j,i) + surf_lsm_h%qsws(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                qsws_av(j,i) = qsws_av(j,i) + surf_usm_h%qsws(m)
              ENDDO
 
@@ -688,22 +711,53 @@
 
           CASE ( 'shf*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   shf_av(j,i) = shf_av(j,i) + shf(j,i)
-                ENDDO
-             ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                shf_av(j,i) = shf_av(j,i) + surf_def_h(0)%shf(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                shf_av(j,i) = shf_av(j,i) + surf_lsm_h%shf(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                shf_av(j,i) = shf_av(j,i) + surf_usm_h%shf(m)
+             ENDDO
+
 
           CASE ( 'ssws*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ssws_av(j,i) = ssws_av(j,i) + ssws(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                ssws_av(j,i) = ssws_av(j,i) + surf_def_h(0)%ssws(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h%ssws(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                ssws_av(j,i) = ssws_av(j,i) + surf_usm_h%ssws(m)
              ENDDO
 
           CASE ( 't*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ts_av(j,i) = ts_av(j,i) + ts(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                ts_av(j,i) = ts_av(j,i) + surf_def_h(0)%ts(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                ts_av(j,i) = ts_av(j,i) + surf_lsm_h%ts(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                ts_av(j,i) = ts_av(j,i) + surf_usm_h%ts(m)
              ENDDO
 
@@ -718,8 +772,18 @@
 
           CASE ( 'u*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   us_av(j,i) = us_av(j,i) + us(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                us_av(j,i) = us_av(j,i) + surf_def_h(0)%us(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                us_av(j,i) = us_av(j,i) + surf_lsm_h%us(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                us_av(j,i) = us_av(j,i) + surf_usm_h%us(m)
              ENDDO
 
@@ -752,22 +816,52 @@
 
           CASE ( 'z0*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   z0_av(j,i) = z0_av(j,i) + z0(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                z0_av(j,i) = z0_av(j,i) + surf_def_h(0)%z0(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                z0_av(j,i) = z0_av(j,i) + surf_lsm_h%z0(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                z0_av(j,i) = z0_av(j,i) + surf_usm_h%z0(m)
              ENDDO
 
           CASE ( 'z0h*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   z0h_av(j,i) = z0h_av(j,i) + z0h(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                z0h_av(j,i) = z0h_av(j,i) + surf_def_h(0)%z0h(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h%z0h(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                z0h_av(j,i) = z0h_av(j,i) + surf_usm_h%z0h(m)
              ENDDO
 
           CASE ( 'z0q*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   z0q_av(j,i) = z0q_av(j,i) + z0q(j,i)
-                ENDDO
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                z0q_av(j,i) = z0q_av(j,i) + surf_def_h(0)%z0q(m)
+             ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h%z0q(m)
+             ENDDO
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+                z0q_av(j,i) = z0q_av(j,i) + surf_usm_h%z0q(m)
              ENDDO
 !             
